/* Blinker
   Copyright 2011 Stefan Schuermans <stefan@blinkenarea.org>
   Copyleft GNU public license - http://www.gnu.org/copyleft/gpl.html
   a blinkenarea.org project */

#ifndef BLINKER_NAME_H
#define BLINKER_NAME_H

#include <string>

namespace Blinker {

/// a name (a wrapper for std::string to use it as templ param of SettingFile)
class Name
{
public:
  /// constructor
  Name();

public:
  /**
   * @brief parse from string format
   * @param[in] str string format
   * @return if parsing was successful
   */
  bool fromStr(const std::string &str);

  /**
   * @brief convert to string format
   * @return string format
   */
  std::string toStr() const;

public:
  std::string m_str; ///< name string
}; // class Name

} // namespace Blinker

#endif // #ifndef BLINKER_NAME_H

