/* Blinker
   Copyright 2011 Stefan Schuermans <stefan@blinkenarea.org>
   Copyleft GNU public license - http://www.gnu.org/copyleft/gpl.html
   a blinkenarea.org project */

#ifndef BLINKER_PROTOCOL_H
#define BLINKER_PROTOCOL_H

#include <string>

#include <BlinkenLib/BlinkenProto.h>

namespace Blinker {

/// a Blinken protocol
class Protocol
{
public:
  /// constructor
  Protocol();

public:
  /**
   * @brief parse from string format
   * @param[in] str string format
   * @return if parsing was successful
   */
  bool fromStr(const std::string &str);

  /**
   * @brief convert to string format
   * @return string format
   */
  std::string toStr() const;

public:
  etBlinkenProto m_proto; ///< protocol
}; // class Protocol

} // namespace Blinker

#endif // #ifndef BLINKER_PROTOCOL_H

