/* Blinker
   Copyright 2011 Stefan Schuermans <stefan@blinkenarea.org>
   Copyleft GNU public license - http://www.gnu.org/copyleft/gpl.html
   a blinkenarea.org project */

#ifndef BLINKER_SIZE_H
#define BLINKER_SIZE_H

#include <string>

namespace Blinker {

/// a Blinken frame size
class Size
{
public:
  /// constructor
  Size();

public:
  /**
   * @brief parse from string format
   * @param[in] str string format
   * @return if parsing was successful
   */
  bool fromStr(const std::string &str);

  /**
   * @brief convert to string format
   * @return string format
   */
  std::string toStr() const;

public:
  unsigned int m_width;  ///< width of the frame in pixels
  unsigned int m_height; ///< height of the frame in pixels
}; // class Size

} // namespace Blinker

#endif // #ifndef BLINKER_SIZE_H

